%global momorel 3
%global md5sum_src0 d4c8e93db23c9b7d06104ce97a182502

%global hal_version  0.5.7
%global dbus_version 0.60

Summary: The Beagle Search Infrastructure
Name: beagle

Version: 0.2.7
Release: %{momorel}m
License: LGPL
Group: User Interface/Desktops
URL: http://beagle-project.org/

%NoSource 0 ftp://ftp.gnome.org/pub/GNOME/sources/%{name}/0.2/%{name}-%{version}.tar.bz2 %{md5sum_src0}
Source1: beagle.desktop

Patch2: beagle-0.2.7-crawl.patch
Patch3: beagle-0.2.1-spew.patch
Patch4: beagle-0.2.6-lib64.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildRequires:  mono-core >= 1.1.15-11m
BuildRequires:  mono-devel mono-data-sqlite
BuildRequires:  gtk-sharp >= 2.8.2-3m
BuildRequires:  zip libexif-devel
##BuildRequires:  gsf-sharp >= 0.6
BuildRequires:  sqlite-devel >= 3.3.5
BuildRequires:  gmime-sharp >= 2.2.1-3m
##BuildRequires:  evolution-sharp >= 0.10.2-3
BuildRequires:  libXScrnSaver-devel
BuildRequires:  gnome-vfs-devel
BuildRequires:  libgnome-devel
BuildRequires:  gtk+-devel >= 2.6.0
BuildRequires:  librsvg-devel >= 2.0
BuildRequires:  wv >= 1.2.1
Requires: sqlite >= 3.3.5
Requires: zip unzip sed grep
PreReq: shadow-utils

# Mono only available on these:
ExclusiveArch: %ix86 x86_64 ppc ia64 armv4l sparc s390 s390x

%description
A general infrastructure for making your data easy to find.

%package -n libbeagle
Summary:      Beagle C interface
Group:        Development/Libraries

%description -n libbeagle
Library to talk to the beagle server in C.

%package -n libbeagle-devel
Summary:      Beagle C interface
Group:        Development/Libraries
Requires:     libbeagle = %{version} libxml2-devel glib-devel

%description -n libbeagle-devel
Library to talk to the beagle server in C.

%package -n libbeagle-python
Summary:      Beagle python interface
Group:        Development/Libraries
Requires:     libbeagle = %{version}
Requires:     python

%description -n libbeagle-python
Python wrappers for libbeagle

%prep
%setup -q
%patch2 -p1 -b .crawl
%patch3 -p1 -b .spew

%build
export MONO_SHARED_DIR=%{buildroot}/%{?buildsubdir}
mkdir -p ${MONO_SHARED_DIR}
autoreconf -fi
%configure --disable-evolution --program-transform-name=""
%make

# Generate the beagle.xpi for mozilla/firefox
pushd .
cd mozilla-extension
%make
popd

%install
rm -rf --preserve-root %{buildroot}
export MONO_SHARED_DIR=%{buildroot}/%{?buildsubdir}
mkdir -p ${MONO_SHARED_DIR}

%make install DESTDIR=%{buildroot}

mkdir -p %{buildroot}/var/cache/beagle/indexes

# Add an autostart file so beagled gets run by default
# (temporarily disabled)
#mkdir -p %{buildroot}/etc/xdg/autostart
#cp %{SOURCE1} %{buildroot}/etc/xdg/autostart

# TODO: Isn't there a better place to install this?
install -m 644 mozilla-extension/beagle.xpi %{buildroot}%{_libdir}/beagle/

desktop-file-install --vendor gnome --delete-original           \
  --dir %{buildroot}%{_datadir}/applications                 \
  --add-only-show-in=GNOME                                      \
  %{buildroot}%{_datadir}/applications/beagle-search.desktop

desktop-file-install --vendor gnome --delete-original           \
  --dir %{buildroot}%{_datadir}/applications                 \
  --remove-category Utility                                     \
  --add-only-show-in=GNOME                                      \
  %{buildroot}%{_datadir}/applications/beagle-settings.desktop

echo "NoDisplay=true" >> %{buildroot}%{_datadir}/applications/gnome-beagle-search.desktop

sed -i -e 's@Icon=tango-system-search@Icon=gnome-search-tool@' %{buildroot}%{_datadir}/applications/gnome-beagle-search.desktop

%find_lang %{name}

rm -f %{buildroot}%{_libdir}/beagle/*.la
rm -f %{buildroot}%{_libdir}/beagle/*.a
rm -f %{buildroot}%{_libdir}/*.la
rm -f %{buildroot}%{_libdir}/*.a
rm -f %{buildroot}%{_libdir}/python*/site-packages/*.a
rm -f %{buildroot}%{_libdir}/python*/site-packages/*.la

chmod a+x %{buildroot}%{_libdir}/beagle/*/*.dll
chmod a+x %{buildroot}%{_libdir}/beagle/*.dll
chmod a+x %{buildroot}%{_libdir}/beagle/*.exe

%post -n libbeagle -p /sbin/ldconfig

%postun -n libbeagle -p /sbin/ldconfig

%pre
%define beagle_user_uid 58

/usr/sbin/groupadd -g %{beagle_user_uid} -r beagleindex 2> /dev/null || :
/usr/sbin/useradd -r -u %{beagle_user_uid} -s /sbin/nologin -c "User for Beagle indexing" -d /var/cache/beagle -g beagleindex beagleindex 2> /dev/null || :

%post
if rpm -q firefox > /dev/null; then
# install the firefox extension
# note that this code is duplicated below in a trigger
  latest=`rpm --query --queryformat "%{VERSION}\n" firefox | head -1 | tr -d "\n\r"`
  if [ -d %{_libdir}/firefox-$latest/extensions ]; then
    cd %{_libdir}/firefox-$latest/extensions
    mkdir beagle-extension
    unzip -q -d beagle-extension %{_libdir}/beagle/beagle.xpi
    id=`grep em:id beagle-extension/install.rdf | head -1 | sed -e 's/^ *//' -e "s/<[^<]*>//g" | tr -d "\n\r"`
    if [ -e "$id" ]; then
      rm -rf beagle-extension
    else
      mv beagle-extension "$id"
    fi
  fi
fi

%clean
rm -rf --preserve-root %{buildroot}

%triggerin -- firefox
# install the firefox extension
latest=`rpm --query --queryformat "%{VERSION}\n" firefox | head -1 | tr -d "\n\r"`
if [ -d /usr/lib64/firefox-$latest/extensions ]; then
  libdir=/usr/lib64
else
  libdir=/usr/lib
fi
if [ -f $libdir/beagle/beagle.xpi ]; then
  cd $libdir/firefox-$latest/extensions
  mkdir beagle-extension
  unzip -q -d beagle-extension $libdir/beagle/beagle.xpi
  id=`grep em:id beagle-extension/install.rdf | head -1 | sed -e 's/^ *//' -e "s/<[^<]*>//g" | tr -d "\n\r"`
  if [ -e "$id" ]; then
    rm -rf beagle-extension
  else
    mv beagle-extension "$id"
  fi
fi

%files
%defattr(-,root,root,-)
%doc COPYING README
%{_sysconfdir}/cron.daily/*
%{_sysconfdir}/beagle
%config(noreplace) %{_sysconfdir}/beagle/crawl-applications
%config(noreplace) %{_sysconfdir}/beagle/crawl-documentation
%config(noreplace) %{_sysconfdir}/beagle/external-filters.xml
%{_bindir}/*
%{_sbindir}/*
%{_libdir}/pkgconfig/beagle*.pc
%{_libdir}/beagle
%{_datadir}/beagle
%{_datadir}/pixmaps/*
%{_datadir}/applications/*
%{_datadir}/locale/*/*/*
%{_mandir}/*/*
%dir %attr(-,beagleindex,beagleindex) /var/cache/beagle
%dir %attr(-,beagleindex,beagleindex) /var/cache/beagle/indexes
#%{_sysconfdir}/xdg/autostart/beagle.desktop

%files -n libbeagle
%defattr(-, root, root)
%{_libdir}/libbeagle.so.*

%files -n libbeagle-devel
%defattr(-, root, root)
%{_includedir}/libbeagle
%{_libdir}/libbeagle.so
%{_libdir}/pkgconfig/libbeagle*.pc

%files -n libbeagle-python
%{_libdir}/python*/site-packages/beagle.so

%changelog
* Sun Aug 13 2006 Ryu SASAOKA <ryu@momonga-linux.org>
- (0.2.7-3m)
- revised for multilibarch

* Wed Jul 12 2006 Ryu SASAOKA <ryu@momonga-linux.org>
- (0.2.7-2m)
- stop beagle-crawl (cron.daily)

* Sun Jul  9 2006 NARITA Koichi <pulsar@sea.plala.or.jp>
- (0.2.7-1m)
- update to 0.2.7

* Sat Jun 24 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (0.2.6-6m)
- depend sqlite3 -> sqlite

* Tue Jun  6 2006 Nishio Futoshi <futoshi@momonga-linux.org>
- (0.2.6-5m)
- Fix BuildPrereq (mono package name changed)

* Thu May 25 2006 Nishio Futoshi <futoshi@momonga-linux.org>
- (0.2.6-4m)
- delete duplicate dir

* Sun May 21 2006 Ryu SASAOKA <ryu@momonga-linux.org>
- (0.2.6-3m)
- BuildRequires:  wv >= 1.2.1

* Wed May 17 2006 Ryu SASAOKA <ryu@momonga-linux.org>
- (0.2.6-2m)
- add Patch4: beagle-0.2.6-lib64.patch

* Tue May 16 2006 Masaru SANUKI <sanuki@momonga-linux.org>
- (0.2.6-1m)
- version 0.2.6
- First import, based on Fedora
